; Demo FastFind (officielle)
#include "FastFind.au3"
#Include <WinAPI.au3>

#RequireAdmin

global const $DEBUG_DEFAULT = 3
global const $DEBUG_GRAPHIC = $DEBUG_DEFAULT + 4
global const $WINDOW_CLASS = "Notepad" ; CLASS de la fentre  dtecter
global const $WINDOW_TITLE = "" ; TITRE de la fentre  dtecter

FFSetDebugMode($DEBUG_GRAPHIC) 	 ; Active le mode dbug avanc, pour avoir des traces + visualisation graphique
FFSetDefaultSnapShot(0)

;MsgBox(0,"Dmo FF", "Mettez une fentre avec des cercles bleus et rouges, puis cliquez sur un point"&@LF&"Pour lancer la recherche du cercle de chaque couleur le plus proche du point dsign par la souris")
TrayTip("Dmo FastFind", "F1 pour dtecter une zone bleue et F2 pour rouge, "&@LF&"F3 pour capturer la fentre Notepad, "&@LF&"F4 pour capturer l'cran complet, "&@LF&"F5 pour dtecter les changements depuis la dernire capture, "&@LF&"F6 pour partir dans une boucle de dtection priodique des changements, "&@LF&"ESC pour terminer",50000)
HotKeySet("{F1}", "DetectBleu")
HotKeySet("{F2}", "DetectBlancNoir")
HotKeySet("{F3}", "SelectWindow")
HotKeySet("{F4}", "SelectScreen")
HotKeySet("{F5}", "ShowChanges")
HotKeySet("{F6}", "PeriodicChanges")
HotKeySet("{ESC}", "TheEnd")
While (1)
	Sleep(10) ; On attend, jusqu' appui sur "ESC" pour quitter
Wend

; On cherche la zone de 43x43 la plus proche du coin sup. gauche (0,0) contenant au moins 100 pixels approchant du bleu.
; Dans un premier passage, on cherche un bleu pur (0x0000FF), et  chaque itration on augmente la tolrance sur la couleur de 5.
; On doit forcment trouver une rponse, au pire avec ShadeVariation = 255 (tous les pixels de l'cran remplissent alors la condition)
;
; Si FFSetDebugMode vaut 7 (le bit 4 est donc  un), la zone dtecte est entoure l'un rectangle rouge
Func DetectBleu()
	FFSetDebugMode($DEBUG_GRAPHIC)
	FFTrace(@lf&"   ** Detection zone proche du bleu"&@lf&"")
	local $ShadeVariation=0
	local $ResBleu
	do
		$ResBleu = FFNearestSpot(0, 0, 0, 0, 43, 100, 100, 100, 0x000000FF, $ShadeVariation, true) ; Force un nouveau snapShot  chaque passage (cf DetectBlancNoir pour optimisation simple possible)
		if (Not IsArray($ResBleu)) Then $ShadeVariation += 5
	until (IsArray($ResBleu) OR $ShadeVariation >250)
	if (IsArray($ResBleu)) Then
		local $sMsg = "Zone 43x43 contenant 100 pixels Bleus trouve (avec ShadeVariation de "&$ShadeVariation&"): la zone la plus proche de (100,100) est en "&$ResBleu[0]&","&$ResBleu[1];
		FFTrace("   ** "&$sMsg&""&@lf&"")
		TrayTip("Zone trouve", $sMsg, 2000)
	Else
		local $sMsg = "Aucune zone contenant du bleu trouve"
		FFTrace("   ** "&$sMsg&@lf&"")
		TrayTip("Pas trouv", $sMsg, 2000)
	EndIf
EndFunc

; On cherche la zone de 10x10 la plus proche du coin sup. gauche (0,0) qui soit totalement soit blanc soit noir.
;
; Si FFSetDebugMode vaut 7 (le bit 4 est donc  un), la zone dtecte est entoure l'un rectangle rouge
Func DetectBlancNoir()
	FFSetDebugMode($DEBUG_GRAPHIC)
	FFTrace(@lf&"   ** FFNearestSpot(0, 0, 0, 0, 43, 100, 0, 0, 0x00FF0000, 0+, true)"&@lf&"")
	local $ShadeVariation=0
	local $ResBlancNoir
	FFResetColors() ; On remet la liste des couleurs  0
	FFAddColor(0x00FFFFFF) ; On ajoute le blanc dans la liste
	FFAddColor(0x00000000) ; On ajoute le noir dans la liste
	local $FirstLoop = true ; Cette variable permet d'optimiser le traitement, en ne faisant une capture en mmoire de l'cran qu'au premier passage. Ainsi les recherches suivantes sont bien plus rapides.
	do
		; [0, 0, 0, 0] => FullScreen, 10 => Taille de la zone  trouver, 100 => Nombre de pixels dans la zone, [0, 0] Coordonnes du point de rfrence, -1 => Utiliser la liste de couleurs, $ShadeVariation => Tolrance sur les couleurs, true => Force un nouveau SnapShot uniquement la premire fois
		$ResBlancNoir = FFNearestSpot(0, 0, 0, 0, 10, 100, 0, 0, -1, $ShadeVariation, $FirstLoop) ; Ne force pas un nouveau snapShot si il y en a dj un
		$FirstLoop = false
		if (Not IsArray($ResBlancNoir)) Then $ShadeVariation += 2

	until (IsArray($ResBlancNoir) OR $ShadeVariation >20)
	if (IsArray($ResBlancNoir)) Then
		local $sMsg = "Zone 10x10 entirement noire et blanche (donc contenant 100 pixels dans ces deux couleurs) trouve (avec ShadeVariation de "&$ShadeVariation&"): la zone la plus proche de (0,0) est en "&$ResBlancNoir[0]&","&$ResBlancNoir[1];
		FFTrace("   ** "&$sMsg&""&@lf&"")
		TrayTip("Zone trouve", $sMsg, 2000)
	Else
		local $sMsg = "Aucun carr de 10x10 ne contenant que du noir et du blanc n'a t trouve"
		FFTrace("   ** "&$sMsg&@lf)
		TrayTip("Pas trouv", $sMsg, 2000)
	EndIf
EndFunc

Func SelectWindow()
	FFTrace(@lf&"   ** SelectWindow"&@lf&"")
	local $hWnd = WinActivate("[CLASS:"&$WINDOW_CLASS&"; TITLE:"&$WINDOW_TITLE&"]", "") ; On tente de capturer une fentre
	if $hWnd="" Then
		$hWnd = WinGetHandle("[ACTIVE]", "") ;  dfaut, on prend la fentre courante
	EndIf
	WinSetOnTop ( $hWnd, "", 1)

	FFSetDebugMode($DEBUG_DEFAULT)
	FFSetWnd($hWnd)
	FFSnapShot()
	TrayTip("Select Window","Title of the Window: "&WinGetTitle($hWnd)&" Class:"&_WinAPI_GetClassName($hWnd), 2000)
	FFTrace("   ** SelectWindow => Title of the Window: "&WinGetTitle($hWnd)&" Class:"&_WinAPI_GetClassName($hWnd)&@lf)
EndFunc

; Slectionne un cran
Func SelectScreen()
	FFTrace(@lf&"   ** SelectScreen"&@lf&"")
	FFSetWnd(0)
	FFSnapShot()
	TrayTip("Select Screen","Select FullScreen", 2000)
EndFunc

Func ShowChanges()
	FFTrace(@lf&"   ** ShowChanges"&@lf)
	FFSetDebugMode($DEBUG_DEFAULT) ; On conserve les traces, mais pas le dbuggage graphique, pour ne pas crer artificiellement des changements qui seraient dtects
	FFSetDefaultSnapShot(1) ; Fait un SnapShot discret sur le Slot N1
	FFSnapShot()
	FFSetDebugMode($DEBUG_GRAPHIC)	 ; Active le mode dbug avanc, pour avoir une messagebox donnant la rponse + infos graphiques
	$Res = FFLocalizeChanges(0, 1) ; Cherche les diffrences entre les SnapShots 0 et 1
	FFSetDefaultSnapShot(0) ; Revient sur le slot N0 pour les prochains SnapShots
	if @Error Then
		TrayTip("ShowChanges","No change detected",2000)
		FFTrace("   ** ShowChanges => No change detected !"&@lf)
	Else
		TrayTip("ShowChanges","Change detected : ("&$Res[0]&","&$Res[1]&","&$Res[2]&","&$Res[3]&"), "&$Res[4]&" pixels are different",2000)
		FFTrace("   ** ShowChanges => Change detected : ("&$Res[0]&","&$Res[1]&","&$Res[2]&","&$Res[3]&"), "&$Res[4]&" pixels are different"&@lf)
	EndIf
EndFunc

; Surveille les changements  l'cran et les affiche (trace graphique (FFSetDebugMode(4)) + TrayTip)
Func PeriodicChanges()
	while 1
		FFSetDebugMode($DEBUG_DEFAULT) ; dsactivation du debuggage (perfs)
		FFSetDefaultSnapShot(0) ; Fait un SnapShot sur le Slot N0
		FFSnapShot()
		Sleep(100)
		FFSetDefaultSnapShot(1) ; Fait un SnapShot sur le Slot N1
		FFSnapShot()
		FFSetDebugMode($DEBUG_GRAPHIC) ; Affichage graphique de la dtection
		$Res = FFLocalizeChanges(0, 1) ; Cherche les diffrences entre les SnapShots 0 et 1
		if @Error Then
			FFTrace("   ** ShowChanges => No change detected !"&@lf)
		Else
			TrayTip("ShowChanges","Change detected : ("&$Res[0]&","&$Res[1]&","&$Res[2]&","&$Res[3]&"), "&$Res[4]&" pixels are different",2000)
			FFTrace("   ** ShowChanges => Change detected : ("&$Res[0]&","&$Res[1]&","&$Res[2]&","&$Res[3]&"), "&$Res[4]&" pixels are different"&@lf)
		EndIf
	Wend

EndFunc

Func TheEnd()
	FFTrace("   ** Bybye"&@lf&@lf)
	CloseFFDll() ; Permet de tout fermer proprement, et librer la mmoire
	Exit
Endfunc